(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@angular/core"), require("@angular/common"));
	else if(typeof define === 'function' && define.amd)
		define(["@angular/core", "@angular/common"], factory);
	else if(typeof exports === 'object')
		exports["ngx-feature-toggle.umd"] = factory(require("@angular/core"), require("@angular/common"));
	else
		root["ngx-feature-toggle.umd"] = factory(root["@angular/core"], root["@angular/common"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_6__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __webpack_require__(0);
var feature_toggle_service_1 = __webpack_require__(2);
var FeatureToggleProviderComponent = (function () {
    function FeatureToggleProviderComponent() {
        this.featureToggleService = {};
        this.currentConfig = {};
    }
    FeatureToggleProviderComponent.prototype.ngOnInit = function () {
        if (typeof this.featureToggleService !== 'object') {
            throw new Error('Attribute `featureToggleService` should not be null or empty');
        }
        this.setFeatureToggles();
    };
    FeatureToggleProviderComponent.prototype.ngDoCheck = function () {
        var shouldUpdateFeatureToggles = this.currentConfig !== this.featureToggleService;
        if (shouldUpdateFeatureToggles) {
            this.setFeatureToggles();
        }
    };
    FeatureToggleProviderComponent.prototype.setFeatureToggles = function () {
        this.currentConfig = this.featureToggleService;
        feature_toggle_service_1.setConfigurationObject(this.featureToggleService);
    };
    return FeatureToggleProviderComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], FeatureToggleProviderComponent.prototype, "featureToggleService", void 0);
FeatureToggleProviderComponent = __decorate([
    core_1.Component({
        selector: 'feature-toggle-provider',
        template: "<ng-content></ng-content>"
    })
], FeatureToggleProviderComponent);
exports.FeatureToggleProviderComponent = FeatureToggleProviderComponent;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*!
 * feature-toggle-service.js v2.0.1
 * https://willmendesneto.github.io/feature-toggle-service.js
 *
 * Licensed MIT © Will Mendes
 */
(function (global, factory) {
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    } else if (typeof exports !== "undefined") {
        factory(exports);
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports);
        global.FeatureToggleService = mod.exports;
    }
})(this, function (exports) {
    "use strict";

    Object.defineProperty(exports, "__esModule", { value: true });
    var settings = {};
    var isOn = function isOn(key) {
        return !!settings[key];
    };
    exports.isOn = isOn;
    var isOff = function isOff(key) {
        return !isOn(key);
    };
    exports.isOff = isOff;
    var setConfigurationObject = function setConfigurationObject(obj) {
        settings = obj;
    };
    exports.setConfigurationObject = setConfigurationObject;
});

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __webpack_require__(0);
var feature_toggle_service_1 = __webpack_require__(2);
var FeatureToggleComponent = (function () {
    function FeatureToggleComponent(_el, _zone) {
        this._el = _el;
        this._zone = _zone;
        this.isEnabled = false;
        this.featureIsEnabled = false;
    }
    FeatureToggleComponent.prototype.ngOnInit = function () {
        if (!this.featureName) {
            throw new Error('Attribute `featureName` should not be null or empty');
        }
        this.checkIfContentShouldBeRendered();
    };
    FeatureToggleComponent.prototype.ngDoCheck = function () {
        var _this = this;
        this._zone.runOutsideAngular(function () {
            _this.checkIfContentShouldBeRendered();
        });
    };
    FeatureToggleComponent.prototype.checkIfContentShouldBeRendered = function () {
        var showWhenDisabled = this._el.nativeElement.getAttribute('showWhenDisabled') !== null;
        var toggleState = feature_toggle_service_1.isOn(this.featureName);
        this.featureIsEnabled = toggleState === !showWhenDisabled;
        if (this.isEnabled !== this.featureIsEnabled) {
            this.isEnabled = this.featureIsEnabled;
        }
    };
    return FeatureToggleComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], FeatureToggleComponent.prototype, "featureName", void 0);
FeatureToggleComponent = __decorate([
    core_1.Component({
        selector: 'feature-toggle',
        template: '<ng-content *ngIf="isEnabled"></ng-content>'
    }),
    __metadata("design:paramtypes", [core_1.ElementRef,
        core_1.NgZone])
], FeatureToggleComponent);
exports.FeatureToggleComponent = FeatureToggleComponent;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var feature_toggle_provider_component_1 = __webpack_require__(1);
exports.FeatureToggleProviderComponent = feature_toggle_provider_component_1.FeatureToggleProviderComponent;
var feature_toggle_component_1 = __webpack_require__(3);
exports.FeatureToggleComponent = feature_toggle_component_1.FeatureToggleComponent;
var feature_toggle_module_1 = __webpack_require__(5);
exports.FeatureToggleModule = feature_toggle_module_1.FeatureToggleModule;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = __webpack_require__(0);
var common_1 = __webpack_require__(6);
var feature_toggle_provider_component_1 = __webpack_require__(1);
var feature_toggle_component_1 = __webpack_require__(3);
var ANGULAR_FEATURE_TOGGLE_DIRECTIVES = [
    feature_toggle_provider_component_1.FeatureToggleProviderComponent,
    feature_toggle_component_1.FeatureToggleComponent
];
var ANGULAR_FEATURE_TOGGLE_PROVIDERS = [];
var FeatureToggleModule = (function () {
    function FeatureToggleModule() {
    }
    return FeatureToggleModule;
}());
FeatureToggleModule = __decorate([
    core_1.NgModule({
        declarations: ANGULAR_FEATURE_TOGGLE_DIRECTIVES,
        exports: ANGULAR_FEATURE_TOGGLE_DIRECTIVES,
        providers: ANGULAR_FEATURE_TOGGLE_PROVIDERS,
        imports: [common_1.CommonModule]
    })
], FeatureToggleModule);
exports.FeatureToggleModule = FeatureToggleModule;


/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ })
/******/ ]);
});
//# sourceMappingURL=ngx-feature-toggle.umd.js.map