"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var feature_toggle_service_1 = require("feature-toggle-service");
var FeatureToggleProviderComponent = (function () {
    function FeatureToggleProviderComponent() {
        this.featureToggleService = {};
        this.currentConfig = {};
    }
    FeatureToggleProviderComponent.prototype.ngOnInit = function () {
        if (typeof this.featureToggleService !== 'object') {
            throw new Error('Attribute `featureToggleService` should not be null or empty');
        }
        this.setFeatureToggles();
    };
    FeatureToggleProviderComponent.prototype.ngDoCheck = function () {
        var shouldUpdateFeatureToggles = this.currentConfig !== this.featureToggleService;
        if (shouldUpdateFeatureToggles) {
            this.setFeatureToggles();
        }
    };
    FeatureToggleProviderComponent.prototype.setFeatureToggles = function () {
        this.currentConfig = this.featureToggleService;
        feature_toggle_service_1.setConfigurationObject(this.featureToggleService);
    };
    return FeatureToggleProviderComponent;
}());
FeatureToggleProviderComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'feature-toggle-provider',
                template: "<ng-content></ng-content>"
            },] },
];
/** @nocollapse */
FeatureToggleProviderComponent.ctorParameters = function () { return []; };
FeatureToggleProviderComponent.propDecorators = {
    'featureToggleService': [{ type: core_1.Input },],
};
exports.FeatureToggleProviderComponent = FeatureToggleProviderComponent;
