"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var feature_toggle_service_1 = require("feature-toggle-service");
var FeatureToggleComponent = (function () {
    function FeatureToggleComponent(_el, _zone) {
        this._el = _el;
        this._zone = _zone;
        this.isEnabled = false;
        this.featureIsEnabled = false;
    }
    FeatureToggleComponent.prototype.ngOnInit = function () {
        if (!this.featureName) {
            throw new Error('Attribute `featureName` should not be null or empty');
        }
        this.checkIfContentShouldBeRendered();
    };
    FeatureToggleComponent.prototype.ngDoCheck = function () {
        var _this = this;
        this._zone.runOutsideAngular(function () {
            _this.checkIfContentShouldBeRendered();
        });
    };
    FeatureToggleComponent.prototype.checkIfContentShouldBeRendered = function () {
        var showWhenDisabled = this._el.nativeElement.getAttribute('showWhenDisabled') !== null;
        var toggleState = feature_toggle_service_1.isOn(this.featureName);
        this.featureIsEnabled = toggleState === !showWhenDisabled;
        if (this.isEnabled !== this.featureIsEnabled) {
            this.isEnabled = this.featureIsEnabled;
        }
    };
    return FeatureToggleComponent;
}());
FeatureToggleComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'feature-toggle',
                template: '<ng-content *ngIf="isEnabled"></ng-content>'
            },] },
];
/** @nocollapse */
FeatureToggleComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_1.NgZone, },
]; };
FeatureToggleComponent.propDecorators = {
    'featureName': [{ type: core_1.Input },],
};
exports.FeatureToggleComponent = FeatureToggleComponent;
